(*  Title:  build the Isac-Kernel: MathEngine & Knowledge
    Author: Walther Neuper, TU Graz, 100808
   (c) due to copyright terms

For creating a heap image of isac see ~~/ROOT.
For debugging see text at begin below, e.g. theory dependencies:
  ~$ evince file:///home/wneuper/.isabelle/isabisac/browser_info/Unsorted/Isac/session_graph.pdf &

ATTENTION: no errors in this theory do not mean that there are no errors in Isac ..
.. open theories collecting files from folders: BaseDefinitions.thy, ProgLang.thy etc.
Errors are rigorously detected by isabelle build.
*)

theory Build_Isac
imports
(*  theory Know_Store imports Complex_Main
    $ISABELLE_ISAC/BaseDefinitions
      ML_file libraryC.sml
      ML_file theoryC.sml
      ML_file unparseC.sml
      ML_file "rule-def.sml"
      ML_file "thmC-def.sml"
      ML_file "eval-def.sml"
      ML_file "rewrite-order.sml"
      ML_file rule.sml
      ML_file "error-pattern-def.sml"
      ML_file "rule-set.sml"
      
      ML_file "store.sml"
      ML_file "check-unique.sml"
      ML_file "specification.sml"
      ML_file "model-pattern.sml"
      ML_file "problem-def.sml"
      ML_file "method-def.sml"
      ML_file "cas-def.sml"
      ML_file "thy-write.sml"
  theory BaseDefinitions imports Know_Store
  $ISABELLE_ISAC/BaseDefinitions
    ML_file termC.sml
    ML_file substitution.sml
    ML_file contextC.sml
    ML_file environment.sml
( ** )    "BaseDefinitions/BaseDefinitions"( **)
(*
      theory Calc_Binop imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
        at $ISABELLE_ISAC/ProgLang
        ML_file evaluate.sml
      theory ListC imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
      theory Program imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
    theory Prog_Expr imports Calc_Binop ListC Program
     theory Prog_Tac imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
      theory Tactical imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
    theory Auto_Prog imports Prog_Tac Tactical
  theory ProgLang imports Prog_Expr Auto_Prog
    at $ISABELLE_ISAC/ProgLang
( ** )    "ProgLang/ProgLang"( **)
(*
  theory MathEngBasic imports
    "$ISABELLE_ISAC/ProgLang/ProgLang" "$ISABELLE_ISAC/Specify/Input_Descript"
    at $ISABELLE_ISAC/MathEngBasic
    ML_file thmC.sml
    ML_file "model-def.sml"
    ML_file problem.sml
    ML_file method.sml
    ML_file "cas-command.sml"
  
    ML_file rewrite.sml
  
    ML_file "istate-def.sml"
    ML_file "calc-tree-elem.sml"
    ML_file "pre-conds-def.sml"
  
    ML_file tactic.sml
    ML_file applicable.sml
  
    ML_file position.sml
    ML_file "ctree-basic.sml"
    ML_file "ctree-access.sml"
    ML_file "ctree-navi.sml"
    ML_file ctree.sml
  
    ML_file "state-steps.sml"
    ML_file calculation.sml
( ** )    "MathEngBasic/MathEngBasic"( **)
(*
    theory Input_Descript imports "$ISABELLE_ISAC/BaseDefinitions/BaseDefinitions"
    $ISABELLE_ISAC/Specify
  theory Specify imports "$ISABELLE_ISAC/ProgLang/ProgLang" Input_Descript
  $ISABELLE_ISAC/Specify
    ML_file formalise.sml
    ML_file "o-model.sml"
    ML_file "i-model.sml"
    ML_file "p-model.sml"
    ML_file model.sml
    ML_file "pre-conditions.sml"
    ML_file refine.sml
    ML_file "mstools.sml" (*..TODO review*)
    ML_file ptyps.sml     (*..TODO review*)
    ML_file "test-out.sml"
    ML_file "specify-step.sml"
    ML_file calchead.sml  (*..TODO review*)
    ML_file "input-calchead.sml"
    ML_file "step-specify.sml"
    ML_file specify.sml
( ** )    "Specify/Specify"( **)
(*
  theory Interpret imports "$ISABELLE_ISAC/Specify/Specify"
  $ISABELLE_ISAC/Interpret
    ML_file istate.sml
    ML_file "sub-problem.sml"
    ML_file "thy-read.sml"
    ML_file "li-tool.sml"
    ML_file "solve-step.sml"
    ML_file "error-pattern.sml"
    ML_file derive.sml
    ML_file "lucas-interpreter.sml"
    ML_file "step-solve.sml"
( ** )    "Interpret/Interpret"( **)
(*
  theory MathEngine imports Interpret.Interpret
  $ISABELLE_ISAC/MathEngine
    ML_file "fetch-tactics.sml"
    ML_file solve.sml
    ML_file step.sml
    ML_file "detail-step.sml"
    ML_file "mathengine-stateless.sml"
    ML_file messages.sml
    ML_file states.sml
( ** )    "MathEngine/MathEngine"( **)
(*
  theory Test_Code imports "$ISABELLE_ISAC/MathEngine/MathEngine"
  $ISABELLE_ISAC/Test_Code
    ML_file "test-code.sml"
( ** )    "Test_Code/Test_Code"( **)
(*
  theory BridgeLibisabelle imports "$ISABELLE_ISAC/MathEngine/MathEngine"
  $ISABELLE_ISAC/BridgeLibisabelle
    ML_file "thy-present.sml"
    ML_file mathml.sml   
    ML_file datatypes.sml
    ML_file "pbl-met-hierarchy.sml"
    ML_file "thy-hierarchy.sml" 
    ML_file "interface-xml.sml"
    ML_file interface.sml
( ** )    "BridgeLibisabelle/BridgeLibisabelle"( **)
(*
    theory Calculation imports Calculation (*preliminary for starting Isabelle/Isac*)
    $ISABELLE_ISAC/BridgeJEdit
      ML_file parseC.sml                                       
      ML_file preliminary.sml
  theory BridgeJEdit imports Calculation (*preliminary for starting Isabelle/Isac*)
  $ISABELLE_ISAC/BridgeJEdit
( ** )    "BridgeLibisabelle/BridgeLibisabelle"( **)
(*
    theory Isac imports  "$ISABELLE_ISAC/MathEngine/MathEngine"
      ML_file parseC.sml
  theory BridgeJEdit imports Isac    
( **)    "BridgeJEdit/BridgeJEdit"  (*DEactivate after devel.of BridgeJEdit*)

          "Knowledge/Build_Thydata" (*imports Isac.thy etc*)

(*//-----------------------------------------------------------------------------------------\\*)
(*\\-----------------------------------------------------------------------------------------//*)
begin
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> 
subsection \<open>make Minisubpbl independent from Thy_Info\<close>
text \<open>
  We want Isac to become independent from sessions Specify, Interpret and Isac.
  This goal will be checked by the tests finally.
  As first step we go top down and make Minisubpbl independent form Thy_Info here
  and make sure, that the right ctxt is passed throughout the code.
  As next step we go bottom up from Thy_Info.get_theory and remove it.
  Afterwards $ISABELLE_ISAC_TEST will be changed accordingly.
\<close>
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/000-comments.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/100-init-rootpbl.sml"
ML \<open>
\<close> ML \<open>
(* Title:  100-init-rootpbl.sml
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.
*)

"----------- Minisubplb/100-init-rootpbl.sml ---------------------";
"----------- Minisubplb/100-init-rootpbl.sml ---------------------";
"----------- Minisubplb/100-init-rootpbl.sml ---------------------";
val (_(*example text*), 
  (model as ("Constants [r = (7::real)]" :: "Maximum A" :: "AdditionalValues [u, v]" :: 
     "Extremum (A = 2 * u * v - u \<up> 2)" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [(u::real) / 2 = r * sin \<alpha>, 2 / v = r * cos \<alpha>]" :: 
     "FunctionVariable a" :: "FunctionVariable b" :: "FunctionVariable \<alpha>" :: 
     "Domain {0 <..< r}" :: "Domain {0 <..< r}" :: "Domain {0 <..< \<pi> / 2}" ::
     "ErrorBound (\<epsilon> = (0::real))" :: []), 
   refs as ("Diff_App", 
     ["univariate_calculus", "Optimisation"],
     ["Optimisation", "by_univariate_calculus"])))
  = Store.get (Know_Store.get_expls @{theory}) ["Diff_App-No.123a"] ["Diff_App-No.123a"];

 Test_Code.init_calc @{context} [(model, refs)];
"~~~~~ fun init_calc , args:"; val (ctxt, [(model, refs as (thy_id, _, _))])
  = (@{context}, [(model, refs)]);
(*old* )val ctxt = thy_id |> ThyC.get_theory_PIDE ctxt |> Proof_Context.init_global
( *new*)val thy = thy_id |> ThyC.get_theory_PIDE ctxt  (*^^^^^^^^^^^^^^^^^^^^^^^^^ misleading*)

(**)val return_nxt_specify_init_calc_PIDE =(**)
Step_Specify.nxt_specify_init_calc_PIDE thy (model, refs);
"~~~~~ fun nxt_specify_init_calc , args:"; val (ctxt, (model, (dI, pI, mI))) = (ctxt, (model, refs));

Step_Specify.initialise_PIDE thy (model, refs);
"~~~~~ fun initialise , args:"; val (ctxt, (fmz, (dI, pI, mI))) = (ctxt, (model, refs));
(*old* )val thy = ThyC.get_theory_PIDE ctxt dI( *old*)
	    val ctxt = Proof_Context.init_global thy (* ctxt restricted to Formalise.refs *)
	    val (pI, (pors, pctxt), mI) = 
        if mI = ["no_met"] 
        then raise error "else not covered by test"
        else
          let
(*old* )     val pors = Problem.from_store ctxt pI |> #model |> O_Model.init thy fmz; (*..TermC.parseNEW'*)
(*old*)     val pctxt = ContextC.initialise' thy fmz;                (*..DUPLICATE ermC.parseNEW'*)
(*old*)   in (pI, (pors, pctxt), mI) end;
( *new*)     val (pors, pctxt) = Problem.from_store ctxt pI |> #model |> O_Model.init_PIDE thy fmz;
          in (pI, (pors, pctxt), mI) end;

(*/------------------- check result of O_Model.init_PIDE ------------------------------------\*)
(*+*)val Free ("r", Type ("Real.real", [])) = Syntax.read_term pctxt "r";
(*+*)val Free ("u", Type ("Real.real", [])) = Syntax.read_term pctxt "u";
(*-------------------- stop step into Step_Specify.nxt_specify_init_calc ---------------------*)

val ((pt, p), tacis) = return_nxt_specify_init_calc_PIDE(* kept for continuation *);
"~~~~~ continue fun init_calc , args:"; val ((pt, p), tacis)
  = ((pt, p), tacis);
	  val tac = case tacis of [] => Tactic.Empty_Tac | _ => (#1 o hd) tacis;

 Test_Code.TESTg_form ctxt (pt,p);
"~~~~~ fun TESTg_form , args:"; val (ctxt, ptp) = (ctxt, (pt,p));
    val (form, _, _) =  ME_Misc.pt_extract ctxt ptp;
val Ctree.ModSpec (_, p_, _, gfr, where_, _) =
    (*case*) form (*of*);
val Pos.Pbl =
      (*case*) p_ (*of*);
    Test_Out.Problem [];
    Test_Out.MethodC [];

(*val return =*)
  Test_Out.PpcKF (Test_Out.Problem [], 
   P_Model.from (Proof_Context.theory_of ctxt) gfr where_);
"~~~~~ fun from , args:"; val (thy, itms, where_) = ((Proof_Context.theory_of ctxt), gfr, where_);

(*//------------------ inserted hidden code ------------------------------------------------\\*)
fun item_from_feedback thy (I_Model.Cor ((d, ts), _)) = P_Model.Correct (UnparseC.term_in_thy thy (Input_Descript.join (d, ts)))
  | item_from_feedback _ (I_Model.Syn c) = P_Model.SyntaxE c
  | item_from_feedback _ (I_Model.Typ c) = P_Model.TypeE c
  | item_from_feedback thy (I_Model.Inc ((d, ts), _)) = P_Model.Incompl (UnparseC.term_in_thy thy  (Input_Descript.join (d, ts)))
  | item_from_feedback thy (I_Model.Sup (d, ts)) = P_Model.Superfl (UnparseC.term_in_thy thy  (Input_Descript.join (d, ts)))
  | item_from_feedback thy (I_Model.Mis (d, pid)) = P_Model.Missing (UnparseC.term_in_thy thy d ^ " " ^ UnparseC.term_in_thy thy  pid)
  | item_from_feedback _ _ = raise ERROR "item_from_feedback: uncovered definition"
fun add_sel_ppc (_: theory) sel {Given = gi, Where = wh, Find = fi, With = wi, Relate = re} x =
  case sel of
    "#Given" => {Given = gi @ [x], Where = wh, Find = fi, With = wi,Relate = re}
  | "#Where" => {Given = gi, Where = wh @ [x], Find = fi, With = wi, Relate = re}
  | "#Find"  => {Given = gi, Where = wh, Find = fi @ [x], With = wi, Relate = re}
  | "#Relate"=> {Given = gi, Where = wh, Find = fi, With = wi, Relate = re @ [x]}
  | "#undef" => {Given = gi @ [x], Where = wh, Find = fi, With = wi, Relate = re} (*ori2itmSup*)
  | _  => raise ERROR ("add_sel_ppc tried to select by \"" ^ sel ^ "\"")
fun add_where {Given = gi, Where = _, Find = fi, With = wi, Relate = re} wh =
  {Given = gi, Where = wh, Find= fi ,With = wi, Relate = re}
fun boolterm2item ctxt (true, term) = P_Model.Correct (UnparseC.term_in_ctxt ctxt term)
  | boolterm2item ctxt(false, term) = P_Model.False (UnparseC.term_in_ctxt ctxt term);
(*\\------------------ inserted hidden code ------------------------------------------------//*)

    fun coll model [] = model
      | coll model ((_, _, _, field, itm_)::itms) =
        coll (add_sel_ppc thy field model (item_from_feedback thy itm_)) itms;
    val gfr = coll P_Model.empty itms;

(*val return =*)
           add_where gfr (map (boolterm2item (Proof_Context.init_global thy)) where_);
"~~~~~ fun add_where , args:"; val ({Given = gi, Where = _, Find = fi, With = wi, Relate = re}, wh)
  = (gfr, (map 
          (boolterm2item ctxt) where_));
"~~~~~ fun boolterm2item , args:"; val () = ();
(*\\------------------ step into nxt_specify_init_calc -------------------------------------//*)
\<close> ML \<open>
\<close> ML \<open>
\<close> 
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/150a-add-given-Maximum.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/150-add-given-Equation.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/200-start-method-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/200-start-method.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/250-Rewrite_Set-from-method-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/250-Rewrite_Set-from-method.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/300-init-subpbl-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/300-init-subpbl.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/400-start-meth-subpbl.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/450-Rewrite_Set_Inst.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/470-Check_elementwise-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/490-nxt-Check_Postcond.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/500-met-sub-to-root.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/530-error-Check_Elementwise.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/600-postcond-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/600-postcond.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/700-interSteps.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/710-interSteps-short.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/790-complete-NEXT_STEP.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/790-complete.sml"
  ML_file "$ISABELLE_ISAC_TEST/Tools/isac/Minisubpbl/800-append-on-Frm.sml"


section \<open>check presence of definitions from directories\<close>

(*declare [[ML_print_depth = 999]]*)
ML \<open>Eval.adhoc_thm; (*from "ProgLang/evaluate.sml" *)\<close>
ML \<open>Rewrite.rewrite_; (*from "ProgLang/rewrite.sml" *)\<close>
ML \<open>Input_Descript.for_real_list; (*from "Input_Descript.thy" *)\<close>
ML \<open>(*Test_Code.me;*)\<close>
text \<open>contextthyOK2xml; (*"xmlsrc/interface-xml.sml"*)\<close>
ML \<open>prog_expr\<close>
                                                         
ML \<open>Prog_Expr.eval_occurs_in\<close>
ML \<open>@{thm last_thmI}\<close>
(** )ML \<open>@{thm Querkraft_Belastung}\<close>( *exception FAIL NONE raised (line 161 of "General/scan.ML")*)

declare [[check_unique = false]]
ML \<open>writeln "**** isac kernel = math-engine + Knowledge complete ******"\<close>
ML \<open>@{theory "Isac_Knowledge"}\<close>
ML \<open>(*get_the ["IsacKnowledge", "Diff", "Theorems", "diff_sin_chain"]
  ERROR: app_py: not found: ["IsacKnowledge", "Diff", "Theorems", "diff_sin_chain"]*)\<close>

section \<open>State of approaching Isabelle by Isac\<close>
text \<open>
  Mathias Lehnfeld gives the following list in his thesis in section 
  4.2.3 Relation to Ongoing Isabelle Development.
\<close>
subsection \<open>(0) Survey on remaining Unsynchronized.ref\<close>
text \<open>
  DONE
\<close>
subsection \<open>(1) Exploit parallelism for concurrent session management\<close>
subsection \<open>(2) Make Isac’s programming language usable\<close>
subsection \<open>(3) Adopt Isabelle’s numeral computation for Isac\<close>
text \<open>
  In 2002 isac already strived for floating point numbers. Since that time
  isac represents numerals as "Free", see below (*1*). These experiments are
  unsatisfactory with respect to logical soundness.
  Since Isabelle now has started to care about floating point numbers, it is high 
  time to adopt these together with the other numerals. Isabelle2012/13's numerals
  are different from Isabelle2011, see "$ISABELLE_ISAC_TEST/Tools/isac/ProgLang/termC.sml".
  
  The transition from "Free" to standard numerals is a task to be scheduled for 
  several weeks. The urgency of this task follows from the experience, 
  that (1.2) for "thehier" is very hard, because "num_str" seems to destroy 
  some of the long identifiers of theorems which would tremendously simplify
  building a hierarchy of theorems according to (1.2), see (*2*) below.
\<close>
ML \<open>(*1*) Free ("123.456", HOLogic.realT)\<close>

subsection \<open>(4) Improve the efficiency of Isac’s rewrite-engine\<close>
subsection \<open>(5) Adopt Isabelle/jEdit for Isac\<close>

end
