(* Quick introduction to ML, session 2 *)
theory ML2_Functions imports Isac.Isac_Knowledge begin

text\<open>
This course follows the book:
J.D.Ullmann, Elements of ML Programming. Prenctice Hall 1998.
Contents:

section {* 3.1 Functions\<close>
ML \<open>
fun add x y = x + y;
add 2 3;
add 3 4;
fun mult x y = x * y;
mult 2 3;
\<close>
ML \<open>
val plus3 = add 3;
plus3 4;
\<close>
ML \<open>
fun calc op_ x y = op_ (x, y);
\<close>
ML \<open>
op+
\<close>
ML \<open>
val op_ = op +;
val add' = calc op_;
add' 3 4;
\<close>
ML \<open>
val op_ = op *;
val add' = calc op_;
add' 3 4;
\<close>

section \<open>3.2 Recursive Functions\<close>
ML \<open>
fun print [] = "";
print [];
(*print [1,2,3] exception Match raised*)
\<close>
ML \<open>
fun print [] = ""
  | print (x :: xs) = "123"; (*Value identifier x,(xs) has not been referenced. *)
print [];
print [1,2,3];
print [1,2,3,4,5,6,7]
\<close>
ML \<open>
fun print [] = ""
  | print (_ :: _) = "123";
print [];
print [1,2,3,4,5,6,7]
\<close>
ML \<open>
fun print [] = "]"
  | print (x :: xs) = (string_of_int x) ^ ", " ^ print xs;
print [];
print [1,2,3];
print [1,2,3,4,5,6,7]
\<close>
ML \<open>
fun print [] =  (writeln "print []: "; "]")
  | print (x :: xs) = 
      (writeln "print (x :: xs): x = "; (string_of_int x) ^ ", " ^ 
      (writeln (string_of_int x); print xs));
\<close>
ML \<open>
print [];
print [1,2,3];
\<close>
ML \<open>
1;
"xcv";
writeln "asd";
\<close>
section \<open>see src/Pure/library.ML, lists as sets\<close>
ML \<open>
member;
member op = [1,2,3,4,5] 3;
member op = [1,2,3,4,5] 7;
\<close>
ML \<open>
insert;
Library.insert;
fun insert eq x xs = if member eq xs x then xs else x :: xs;
\<close>
ML \<open>
insert op = 1 [1,2,3];
insert op = 4 [1,2,3];
\<close>
ML \<open>
insert;
Library.insert;
fun insert eq x xs = 
  if member eq xs x 
  then (writeln "then"; xs) 
  else (writeln "else"; x :: xs);
insert op = 1 [1,2,3];
insert op = 4 [1,2,3];
\<close>

ML \<open>
merge;
\<close>

ML \<open>
merge op = ([], []);
merge op = ([1,2], []);
merge op = ([], [4,5]);
merge op = ([1,2], [4,5]);
merge op = ([3,4], [4,5]);
\<close>

ML \<open>
union;
\<close>

ML \<open>
union op = [3,4] [4,5];
\<close>
end
